// Liest wert an analogen Eingang ein (10k-Poti)
// und gibt ihn an die serielle Schnittstelle aus.

#include <reg167.h>
#include <stdio.h>
#include <math.h>
#include <intrins.h>
#include <string.h>

sbit P310 = P3^10;     //port 3 register/bit 10
sbit DP310 = DP3^10;   //DP3-port 3 direction control register

bit secflag;

float idata k;


/******************************************************************/
void tickerint (void) interrupt 0x20 
{	secflag=1;
}
/******************************************************************/

void main(void)
{
//Initialisation

// Serial Port siehe Manual 10-1 ff

   P310=1;         // set Port 3.10 output latch TxD 
   DP310=1;        // set Port 3.10 direction control TxD out      
   S0TIC=0x80;     // set transmit interrupt flag
					//Manual 10-12, S0TIR=1, (Tramit Int. Request)
   S0BG= 0x33;     // set baudrate 9600 @ 16 MC CPU clock 
				   // Manual 10-11,asynchron, S0BRS=0
   S0CON=0x8011;   // set serial mode(1000 0000 0001 0001),
            	   // enable rec.,8bit data async,1stop bit
					//Manual 10-2

// Timer0
// Manual 14-5

T01CON=0x0047;     //CAPCOM Timer 0&1 control register
	           // x 0 xx 0 000   x 1 xx 0 111
	           // timer mode run enable, prescaler 1024

T0= -15625;        //Timer 0 register
T0REL= -15625;     //timer0 reload register ticker 1 s 
T0IC=0x44;         //Timer 0 interrupt enable T0IE=1; ILVL=1; GLVL=0;
		   
//AD converter
//Manual 16-1

ADCON=0x0002;		//Channel AN2 gewaehlt

puts("OK\n");

IEN=1;				//Interrupt enable control bit

while(1)
{
	   
while (!secflag) _idle_();
secflag=0;


ADST=1;        //ADSTART Manual 16-3
while (ADBSY);
    
k=ADDAT & 0x03ff;  //ADDAT-A/D converter result register, 10 bits mask

printf("k=%4.0f    R-Poti=%6.2f [kOhm]   U=%6.2f [V]\n",k,10.0*k/1024.0,5.0*k/1024.0);

}
}

